#include<reg51.h>
/*********************************************
Declaring control pins of the seven segments
*********************************************/
 sbit dig_ctrl_1=P3^5;              
 sbit dig_ctrl_2=P3^4;
/*********************************************/
sbit mot1=P3^0;
sbit mot2=P3^1;	   
//////////////////////////////////////////////
sbit trigger = P2^0;
/*********************************************
Declaring variables
*********************************************/
 unsigned char dig_disp,start_timer_min,end_timer_min,start_timer_hour,end_timer_hour,delay_time,test,disable=0;	
 unsigned int min,sec,hour,hour_dis,temp_min,temp_hour;
/*********************************************
Display buffer. [0 to 9]
*********************************************/
volatile unsigned char digi_val[2]={0xBE,0x73};
volatile unsigned char digi_val1[2]={0x5E,0x3F};
volatile unsigned char digi_val2[2]={0x6D,0x78};
volatile unsigned char temp[2];
volatile unsigned char k,xv;
/*********************************************
Function to provide a time delay of approx. 1
second. using Timer 1.
*********************************************/

void delay()                     
{
    int i;
    for(i=0;i<20;i++)
    {
     TL1=0xFD;
     TH1=0x4B;
     TR1=1;
     while(TF1==0);
     TR1=0;
     TF1=0;
    }
}	   
 /*
void delay_ms(int time)        //This function produces a delay in msec.
{
    int i,j;
    for(i=0;i<time;i++)
     for(j=0;j<1275;j++);
}	  */
/*********************************************
Up
*********************************************/
void up()
{
  mot1=	0;
  mot2= 1;
  for(k=0;k<=1;k++)
  {
	  temp[k]= digi_val[k];

  }
}
/*********************************************
Down
*********************************************/
void down()
{
  mot1=	1;
  mot2= 0;
  for(k=0;k<=1;k++)
  {
	  temp[k]= digi_val1[k];

  }
}
/*********************************************
Up
*********************************************/
void stop()
{
  mot1=	0;
  mot2= 0;

  for(k=0;k<=1;k++)
  {
	  temp[k]= digi_val2[k];

  }
}
/*********************************************
interrupt form the tsop 1738 is registerd
here
*********************************************/
void TSOP(void) interrupt 0    
{
P2=~P2;
xv=xv+1;
if(xv==4)
xv=0;
delay();
/*
P2=~P2;
 xv=xv++;
 P2=xv;
// delay();
 if(xv==2)
 xv=0;
  */
}
/*********************************************
Function to display the number using seven 
segment multiplexing. 
*********************************************/

void display() interrupt 1        
{ 
    TL0=0x36;                     
    TH0=0xf6;
//	IP=0x02;
   	dig_ctrl_1 =dig_ctrl_2=0 ;
	dig_disp=dig_disp++;
    switch(dig_disp)
    {
        case 1:
		P1=temp[0];
        dig_ctrl_1 = 1;
        break;
   		case 2:
		P1=temp[1];
        dig_ctrl_2 = 1;
		dig_disp=0;
		break;
		
    }
}	  
/*********************************************
Main function..
*********************************************/
void main()
{

	end_timer_hour =0;
	TMOD=0x11;        //Intialize Timer 0
	TL0=0x36;
	TH0=0xF6;
	IE=0x83;          // Enable Timer 0 interrupt
	TR0=1;            //Start Timer 0
	stop();

	while(1)          //Start clock
	 {
		  switch (xv)
		  {
		  case 0:
			 stop();
		  break;
		  case 1:
			  up();
		  break;
		  case 2:
		      stop();
		  break;
		  case 3:
		 	 down();
		  break; 
		  }
		 
	  }
}